//----------------------------------------------------------------------------------
// aviutl GPUF␳tB^
// Copyright (c) 2006,2007  N099
//----------------------------------------------------------------------------------
#include <windows.h>
#include <xmmintrin.h>
#include <strsafe.h>
#include <new>

#include <d3d9.h>
#include <d3dx9.h>
#include <dxerr.h>

#include "filter.h"
#include "gpufilter.h"

//---------------------------------------------------------------------
// global
//---------------------------------------------------------------------
GpuFilter *g_pGpuFilter = NULL;
bool g_chg_param = true;
bool g_need_realloc = true;

//ptH[}Xp
#ifdef PROFILE_GPU
struct PCount { LARGE_INTEGER c; TCHAR s[16]; };
HWND g_debugWindow = 0;
double g_QPFreq = 1.0;
PCount g_count[6];
void getCount(int i, const TCHAR *tag);
void printCount(int n);
#else
#define getCount(i, t)
#define printCount(n)
#endif

//---------------------------------------------------------------------
// tB^\̒`
//---------------------------------------------------------------------
// UNICODErh邽ߏςɂȂĂ܂iDXTrace()Ȃ߁j
LPSTR track_name[TRACK_N] =
{ "Y(offs)", "Y(gain)" ,  "Cb(offs)", "Cb(gain)",
  "Cr(offs)", "Cr(gain)", "R(offs)",  "R(gain)",  "R(gamm)", 
  "G(offs)",  "G(gain)",  "G(gamm)",  "B(offs)",  "B(gain)", "B(gamm)", "Format" };
int track_default[TRACK_N] = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
int track_s[TRACK_N] = { -256, -256, -256, -256, -256, -256, -256, -256, -256, -256, -256, -256, -256, -256, -256, 0 };
int track_e[TRACK_N] = { 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 4 };

LPSTR check_name[] =
{ "RGB𓯊", "BT.709ϊg" };
int check_default[] = { 0, 0 };

FILTER_DLL filter = {
	FILTER_FLAG_EX_INFORMATION, 0, 0,
#ifdef PROFILE_GPU
	(TCHAR*)"GPUF␳(Prof)",
#else
	(TCHAR*)"GPUF␳",
#endif
	TRACK_N, (TCHAR**)track_name, track_default, track_s, track_e,
	CHECK_N, (TCHAR**)check_name, check_default,
	func_proc,
	func_init,
	func_exit,
	func_update,
	func_WndProc,
	NULL, NULL, NULL, 0,
	(TCHAR*)"gpu_cc by N099, ver1.9",
	NULL,  NULL,
};

//---------------------------------------------------------------------
// tB^\̂̃|C^n֐
//---------------------------------------------------------------------
EXTERN_C FILTER_DLL __declspec(dllexport) * __stdcall GetFilterTable( void )
{
	return &filter;
}

//---------------------------------------------------------------------
// ɌĂ΂֐
//---------------------------------------------------------------------
BOOL func_init(FILTER *fp)
{
	//GpuFilter
	g_pGpuFilter = new(std::nothrow) GpuFilter;
	if(NULL == g_pGpuFilter){
		return FALSE;
	}

	//FfoCX̃eXgs
	if(!g_pGpuFilter->Init(fp)){
		SAFE_DELETE(g_pGpuFilter);
		return FALSE;
	}

#ifdef PROFILE_GPU
	//get PerformanceCounter frequency
	LARGE_INTEGER ticFreq = {0,0};
	QueryPerformanceFrequency(&ticFreq);
	if(ticFreq.QuadPart>0){
		g_QPFreq = (double)ticFreq.QuadPart;
	}

	//create debug window
	g_debugWindow = CreateWindow(TEXT("EDIT"), TEXT("Debug GPU_CC"),
		WS_VISIBLE | WS_POPUPWINDOW | WS_CAPTION | ES_MULTILINE | ES_READONLY,
		CW_USEDEFAULT, 0,
		180, 160,
		fp->hwnd, NULL, fp->dll_hinst, NULL);
	if(g_debugWindow){
		SendMessage(g_debugWindow, WM_SETFONT, 
			(WPARAM)GetStockObject(OEM_FIXED_FONT), (LPARAM)TRUE);
	}
#endif

	return TRUE;
}

//---------------------------------------------------------------------
// IɌĂ΂֐
//---------------------------------------------------------------------
BOOL func_exit(FILTER *fp)
{
#ifdef PROFILE_GPU
	if(g_debugWindow) DestroyWindow(g_debugWindow);
#endif

	SAFE_DELETE(g_pGpuFilter);

	return TRUE;
}


//---------------------------------------------------------------------
// tB^֐
//---------------------------------------------------------------------
BOOL func_proc(FILTER *fp, FILTER_PROC_INFO *fpip)
{
	int i =0;

	if(!g_pGpuFilter) return FALSE;

#ifdef PROFILE_GPU
	//GPȔI҂
	g_pGpuFilter->FlushCommand();
	getCount(i++, TEXT("Init"));
#endif

	//TCYύX̃`FbN
	if(fpip->w != g_pGpuFilter->GetWidth() || fpip->h != g_pGpuFilter->GetHeight()){
		g_need_realloc = true;
	}

	//foCX̏Ԃ`FbN
	if(!g_pGpuFilter->TestDeviceState(&g_need_realloc)) return FALSE;

	//p[^ύXꂽꍇ
	if(g_need_realloc){
		GpuFilter::PIXEL_FORMAT fmt = g_pGpuFilter->PixelFormatFromIndex(fp->track[T_FMT]);

		g_pGpuFilter->ReleaseResources();
		g_pGpuFilter->AllocResources(fpip->w, fpip->h, fpip->max_w,	fmt);
		g_pGpuFilter->SetParams(fp->track, fp->check);
#ifdef PROFILE_GPU
		g_pGpuFilter->FlushCommand();
		getCount(i++, TEXT("Alloc"));
#endif

		g_need_realloc = false;
		g_chg_param = false;
	}else if(g_chg_param){
		g_pGpuFilter->SetParams(fp->track, fp->check);
#ifdef PROFILE_GPU
		g_pGpuFilter->FlushCommand();
		getCount(i++, TEXT("Param"));
#endif
		g_chg_param = false;
	}

	//f[^GPUɓ]
	if(!g_pGpuFilter->PutImage(fpip->ycp_edit)) return FALSE;
#ifdef PROFILE_GPU
	g_pGpuFilter->FlushCommand();
	getCount(i++, TEXT("Put  "));
#endif

	//GPUŏ
	if(!g_pGpuFilter->ProcImage()) return FALSE;
#ifdef PROFILE_GPU
	g_pGpuFilter->FlushCommand();
	getCount(i++, TEXT("Proc "));
#endif

	//o̓f[^o
	if(!g_pGpuFilter->GetImage(fpip->ycp_edit)) return FALSE;
	getCount(i++, TEXT("Get  "));

	printCount(i);

	return TRUE;
}

//---------------------------------------------------------------------
// ݒύXɌĂ΂֐
//---------------------------------------------------------------------
BOOL func_update(FILTER *fp, int status)
{
	g_chg_param = true;

	if(g_pGpuFilter){
		if(g_pGpuFilter->GetPixelFormat() 
			!= g_pGpuFilter->PixelFormatFromIndex(fp->track[T_FMT]))
		{
			g_need_realloc = true;
		}
	}

	if(fp->check[C_SYRGB]){
		bool upd = false;
		int *tr = fp->track;
		for(int i=0; i<3; ++i){
			if(tr[T_ROF+i] == tr[T_ROF+i+3] && tr[T_ROF+i] == tr[T_ROF+i+6]){
				continue;
			}else if(tr[T_ROF+i] == tr[T_ROF+i+3]){
				tr[T_ROF+i] = tr[T_ROF+i+3] = tr[T_ROF+i+6];
			}else if(tr[T_ROF+i+3] == tr[T_ROF+i+6]){
				tr[T_ROF+i+3] = tr[T_ROF+i+6] = tr[T_ROF+i];
			}else{
				tr[T_ROF+i+6] = tr[T_ROF+i] = tr[T_ROF+i+3];
			}
			upd = true;
		}
		if(upd) fp->exfunc->filter_window_update(fp);
	}

	return TRUE;
}

//---------------------------------------------------------------------
// ݒEBhEɃEBhEbZ[WɌĂ΂֐
//---------------------------------------------------------------------
BOOL func_WndProc(HWND hwnd,UINT message,WPARAM wparam,LPARAM lparam,void *editp,FILTER *fp)
{
	HWND h = NULL;

	switch(message){
	case WM_FILTER_CHANGE_ACTIVE: //tB^̗L/ύXꂽɑ܂
		if(g_pGpuFilter && !fp->exfunc->is_filter_active(fp)){
			g_pGpuFilter->ReleaseResources();
			g_need_realloc = true;
		}
		break;
	case WM_FILTER_CHANGE_PARAM:
		if(!fp->exfunc->is_filter_active(fp)){
			func_update(fp, wparam);
		}
		break;
	default:
		break;
	}

	return FALSE;
}

#if 0
//---------------------------------------------------------------------
// D3DC^[tF[XOɓn֐
//---------------------------------------------------------------------
EXTERN_C BOOL __declspec(dllexport) __stdcall
GetD3D9Interface(IDirect3D9 **ppD3D, IDirect3DDevice9 **ppD3DDev)
{
	if(!ppD3D || !ppD3DDev || !g_pGpuFilter){
		return FALSE;
	}

	//GpuFilter͍쐬ς
	if(g_pGpuFilter->GetD3DInterface(*ppD3D, *ppD3DDev)){
		//AddRefsĂ̂Œ
		return TRUE;
	}else{
		return FALSE;
	}
}
#endif

//ptH[}Xp
#ifdef PROFILE_GPU
void getCount(int i, const TCHAR *tag)
{
	QueryPerformanceCounter(&g_count[i].c);
	lstrcpy(g_count[i].s, tag);
}

void printCount(int n)
{
	TCHAR buf[512];
	TCHAR buf0[64];
	const TCHAR *fmt = TEXT("?");
	double ticks,rQPF;
	int h,w;

	if(NULL == g_debugWindow) return;
	if(g_pGpuFilter){
		h = g_pGpuFilter->GetHeight();
		w = g_pGpuFilter->GetWidth();
		fmt = g_pGpuFilter->GetPixelFormatStr();
	}else{
		h = w = 0;
	}

	rQPF = 1.0 / g_QPFreq;
#if 0
	StringCchPrintf(buf, 512,
		TEXT("Size :%dx%d(%s)\r\nQPF  :%.5E\r\n"), w,h, fmt, g_QPFreq);
#else
	StringCchPrintf(buf, 512, TEXT("Size :%dx%d(%s)\r\n"), w,h, fmt);
#endif
	for(int i=1; i<n; ++i){
		ticks = (double)(g_count[i].c.QuadPart - g_count[i-1].c.QuadPart) * rQPF;
		StringCchPrintf(buf0, 64, TEXT("%s:%.5E\r\n"), g_count[i].s, ticks);
		lstrcat(buf, buf0);
	}
	SendMessage(g_debugWindow, WM_SETTEXT, 0, (LPARAM)buf);  
}
#endif
