//----------------------------------------------------------------------------------
// aviutl  GPUF␳tB^
// Copyright (c) 2006,2007  N099
//----------------------------------------------------------------------------------
#pragma once

//p[^`Ȃ
#define TRACK_N 16
enum { T_YOF, T_YGA, T_CBOF, T_CBGA, T_CROF, T_CRGA,
	T_ROF, T_RGA, T_RGM, T_GOF, T_GGA, T_GGM, T_BOF, T_BGA, T_BGM, T_FMT };

#define PARAM_N 5
enum { PARAM_YC_OFFS, PARAM_YC_GAIN, PARAM_BGR_OFFS, PARAM_BGR_GAIN, PARAM_BGR_GAMMA };

#define CHECK_N 1
enum { C_SYRGB, C_709 };

#define CMAT_N 2
enum { MAT_YC2BGR, MAT_BGR2YC };

#define ETEC_N 4
enum { TEC_FLOAT, TEC_UI16, TEC_SI16, TEC_UI10 };

//_Ci~bNeNX`𗘗p
#define USE_DYNAMIC_TEXTURE

//GPUtB^NX
class GpuFilter
{
public:
	enum PIXEL_FORMAT { F32 = 0, F16, U16, S16, U10, Unknown };

private:
	IDirect3D9 *m_pD3D; //IDirect3D9IuWFNg
	IDirect3DDevice9 *m_pd3dDevice; //D3DfoCX

	IDirect3DTexture9 *m_pTexSrc; //ÕeNX`
	IDirect3DSurface9 *m_pSrfDst; //ʂi[T[tFX
	IDirect3DSurface9 *m_pSrfSys; //Rs[ɗpT[tFX
	
	IDirect3DVertexBuffer9 *m_pVert; //`p_
	IDirect3DVertexDeclaration9 *m_pVertDec; //`p_錾

	ID3DXEffect *m_pEffect; //GtFNg
	IDirect3DQuery9* m_pQuery;

	__m128 *m_pFloatTmp;

	//p[^
	D3DXHANDLE m_hParam[PARAM_N];
	D3DXHANDLE m_hMat[CMAT_N];
	D3DXHANDLE m_hTec[ETEC_N];

	int m_width;
	int m_height;
	int m_wMax;

	bool m_sse;

	PIXEL_FORMAT m_pixFormat; //sNZtH[}bg
	bool m_pixFormatAvailable[Unknown];

public:
	GpuFilter();
	~GpuFilter();

	bool Init(FILTER *fp);
	bool AllocResources(int w, int h, int w_max, PIXEL_FORMAT fmt);
	bool ReleaseResources(void);
	bool SetParams(int *track, int *check);
	bool TestDeviceState(bool *need_realloc);
	bool PutImage(const PIXEL_YC *data);
	bool GetImage(PIXEL_YC *data);
	bool ProcImage(void);

	bool GetD3DInterface(IDirect3D9* &pD3D, IDirect3DDevice9* &pd3dDevice);

	int GetWidth(void) const { return m_width; }
	int GetHeight(void) const { return m_height; }
	PIXEL_FORMAT GetPixelFormat(void) const { return m_pixFormat; }
	const TCHAR *GetPixelFormatStr(void) const;
	PIXEL_FORMAT PixelFormatFromIndex(int i) const
	{ return (PIXEL_FORMAT)((i<0) ? 0 : ((i>Unknown) ? Unknown : i)); }
#ifdef PROFILE_GPU
	void FlushCommand(void);
#endif
private:
	HRESULT CheckDeviceCap(void);
	HRESULT CreateEffect(const TCHAR *res, HMODULE hm);
	HRESULT CreateVert(void);
	HRESULT CreateTexture(IDirect3DTexture9 **ppTex, DWORD usage, D3DPOOL pool);
	HRESULT CreateSurface(IDirect3DSurface9 **ppSrf, DWORD usage, D3DPOOL pool);
	HRESULT CreateSysMemResources(void);
	HRESULT CreateDefaultResources(void);
	HRESULT Reset(void);
	HRESULT PutPixelData(IDirect3DSurface9 *dst, IDirect3DSurface9 *tmp, const PIXEL_YC *src);
	HRESULT PutPixelData(IDirect3DSurface9 *dst, const PIXEL_YC *src);
	HRESULT GetPixelData(PIXEL_YC *dst, IDirect3DSurface9 *src, IDirect3DSurface9 *tmp);
	HRESULT ShowMessageBox(const char *file, DWORD line, HRESULT hr, const TCHAR *msg);

	D3DFORMAT PicFmtToD3DFmt(PIXEL_FORMAT p) const;
#ifdef PROFILE_GPU
	HRESULT CreateQuery(void);
#endif
};

//---------------------------------------------------------------------
// macro
//---------------------------------------------------------------------
#ifndef SAFE_DELETE
#define SAFE_DELETE(p)       { if(p) { delete (p);     (p)=NULL; } }
#endif    
#ifndef SAFE_DELETE_ARRAY
#define SAFE_DELETE_ARRAY(p) { if(p) { delete[] (p);   (p)=NULL; } }
#endif    
#ifndef SAFE_RELEASE
#define SAFE_RELEASE(p)      { if(p) { (p)->Release(); (p)=NULL; } }
#endif
